export default class dom {
	static create(name, props) {
		let el;
		name = name.trim();
		if (name[0] == "<") {
			// console.log('template', name.slice(0,32));
			let temp = document.createElement('template');
			temp.innerHTML = name;
			el = temp.content.cloneNode(true);
			if (!el) { throw("template failed"); }
		}
		else {
			// console.log('create', name);
			el = document.createElement(name);
		}

		return props ? dom.props(el, props) : el;
	}

	static props(el, props) {
		for (var name in props) {
			switch (name) {
				case 'id':
					el.id = props.id;
					break;
				case 'class':
					if ("classList" in el === false) throw ("Dev: don't set properties for template")
					if (props.class) el.classList.add(...(props.class.split(' ')));
					break;
				case 'style':
					if (props.style) el.style = props.style;
					break;
				case 'append':
					if (props.append) {
						if (Array.isArray(props.append)) {
							for (var e in props.append) {
								el.appendChild(props.append[e]);
							}
						}
						else {
							el.appendChild(props.append);
						}
					}
					break;
				case 'appendTo':
					props.appendTo.appendChild(el);
					break;
				case 'text':
					if (props.text) {
						// if is single line and contains \\ and no \, then (php class with namespace) replace all \\ with \
						if (!props.text.includes("\n") && props.text.includes("\\\\")) {
							let parts = props.text.split("\\\\");
							if (!parts.join('').includes("\\")) {
								props.text = parts.join("\\");
							}
						}
						el.innerText = props.text;
					}
					break;
				case 'html':
					if (props.html) el.innerHTML = props.html;
					break;
				case 'title':
					if (props.title) el.title = props.title;
					break;
				case 'data':
					for (var name in props.data) {
						el.dataset[name] = props.data[name];
					}
					break;
				default:
					el[name] = props[name];
			}
		}

		return el;
	}

	static htmlEntities(str) {
		return String(str).replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;').replace(/"/g, '&quot;');
	}
}
dom.div = dom.create.bind(null, 'div');
dom.span = dom.create.bind(null, 'span');
dom.table = dom.create.bind(null, 'table');
dom.colgroup = dom.create.bind(null, 'colgroup');
dom.col = dom.create.bind(null, 'col');
dom.thead = dom.create.bind(null, 'thead');
dom.tbody = dom.create.bind(null, 'tbody');
dom.tfoot = dom.create.bind(null, 'tfoot');
dom.tr = dom.create.bind(null, 'tr');
dom.th = dom.create.bind(null, 'th');
dom.td = dom.create.bind(null, 'td');
dom.ul = dom.create.bind(null, 'ul');
dom.li = dom.create.bind(null, 'li');
dom.dl = dom.create.bind(null, 'dl');
dom.dt = dom.create.bind(null, 'dt');
dom.dd = dom.create.bind(null, 'dd');
dom.code = dom.create.bind(null, 'code');