import dom from "../elements/Dom.js";
import Sortable from "../elements/Sortable.js";
import Tabable from "../elements/Tabable.js";

export default class RequestPage {
	constructor(request, prefix) {
		// console.log('RequestPage::construct', request, prefix);
		// this.request = request;
		this.name = prefix + '-pg-request';
		this.tabs = new Tabable({}, 'Request', prefix + '-pg');
	}

	get() {
		return this.tabs.get();
	}

	headers(data) {
		let table = new Sortable(
			{
				Name: { width: "35%" },
				Value: { width: "65%", code: true }
			},
			this.name + '-headers'
		);

		let rows = [];
		for (let key in data) {
			let head = data[key].split(':');
			rows.push({
				'Name': head[0].trim(),
				'Value': head[1].trim()
			})
		}
		table.addRows(rows);

		this.tabs.append('Headers', table.get());
		this.tabs.enable('Headers');

		this.tabs.initClick('Headers');
	}

	rawPost(formData) {
		let rows = [];
		let searchParams = new URLSearchParams(formData);
		for (let pair of searchParams.entries()) {
			rows.push({
				Name: pair[0],
				Value: pair[1]
			});
		}

		let table = new Sortable(
			{
				Name: { width: "35%" },
				Value: { width: "65%", code: true }
			},
			this.name + '-formdata'
		);

		table.addRows(rows);

		this.tabs.append('Form data', table.get());
		this.tabs.enable('Form data');
	}
}